/*
 * Pais.java
 *
 * Created on 25 de Setembro de 2006, 18:10
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package classes;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;

/**
 *
 * @author vitor
 */
public class Pais {
    private String nome;
    private Cidade capital;
    private SortedSet<Estado> estados = new TreeSet<Estado>();
    
    public Pais(String nome, Cidade capital) {
        this.nome = nome;
        this.capital = capital;
    }
    
    public String getNome() {
        return nome;
    }
    
    public void setNome(String nome) {
        this.nome = nome;
    }
    
    public Cidade getCapital() {
        return capital;
    }
    
    public void setCapital(Cidade capital) {
        this.capital = capital;
    }
    
    public void addEstado(Estado estado) {
        estados.add(estado);
    }
    
    public Collection<Estado> getEstados() {
        return estados;
    }
    
    public String toString() {
        return nome;
    }
    
    public static Set<Pais> listPaises() {
        Set<Pais> paises = new HashSet<Pais>();
        paises.add(new Pais("Brasil", new Cidade("Brasília")));
        paises.add(new Pais("Argentina", new Cidade("Buenos Aires")));
        paises.add(new Pais("Chile", new Cidade("Santiago")));
        paises.add(new Pais("Venezuela", new Cidade("Caracas")));
        paises.add(new Pais("Peru", new Cidade("Lima")));
        paises.add(new Pais("Colômbia", new Cidade("Bogotá")));
        paises.add(new Pais("Paraguai", new Cidade("Assunção")));
        return paises;
    }
    
    public static Pais buildBrasil() {
        Pais brasil = new Pais("Brasil", new Cidade("Brasília"));
        
        Estado es = new Estado("Espírito Santo");
        es.addCidade(new Cidade("Vitória"));
        es.addCidade(new Cidade("Vila Velha"));
        es.addCidade(new Cidade("Cariacica"));
        es.addCidade(new Cidade("Serra"));
        brasil.addEstado(es);
        
        Estado rj = new Estado("Rio de Janeiro");
        rj.addCidade(new Cidade("Rio de Janeiro"));
        rj.addCidade(new Cidade("Niterói"));
        rj.addCidade(new Cidade("Cabo Frio"));
        rj.addCidade(new Cidade("Volta Redonda"));
        brasil.addEstado(rj);
        
        Estado sp = new Estado("São Paulo");
        sp.addCidade(new Cidade("São Paulo"));
        sp.addCidade(new Cidade("Campinas"));
        sp.addCidade(new Cidade("Santos"));
        brasil.addEstado(sp);
        
        return brasil;
    }
}
