/*
 * JanelaArvore.java
 *
 * Created on 28 de Setembro de 2006, 15:46
 */

package parte03;

import classes.Cidade;
import classes.Estado;
import classes.Pais;
import java.awt.Component;
import java.net.URL;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

/**
 *
 * @author  vitor
 */
public class JanelaArvore extends javax.swing.JFrame {
    private DefaultTreeModel modelo;
    
    /** Creates new form JanelaArvore */
    public JanelaArvore() {
        initComponents();
        initModel();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        scrollPane = new javax.swing.JScrollPane();
        tree = new javax.swing.JTree();
        botaoExcluir = new javax.swing.JButton();
        botaoAdicionar = new javax.swing.JButton();
        botaoVer = new javax.swing.JButton();
        botaoAlterar = new javax.swing.JButton();
        labelImagem = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("\u00c1rvore");
        tree.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                treeValueChanged(evt);
            }
        });

        scrollPane.setViewportView(tree);

        botaoExcluir.setText("Excluir");
        botaoExcluir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botaoExcluirActionPerformed(evt);
            }
        });

        botaoAdicionar.setText("Adicionar");
        botaoAdicionar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botaoAdicionarActionPerformed(evt);
            }
        });

        botaoVer.setText("Ver");
        botaoVer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botaoVerActionPerformed(evt);
            }
        });

        botaoAlterar.setText("Alterar");
        botaoAlterar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botaoAlterarActionPerformed(evt);
            }
        });

        labelImagem.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(botaoVer)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(botaoAdicionar)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(botaoExcluir)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(botaoAlterar))
                    .add(layout.createSequentialGroup()
                        .add(scrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 186, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(labelImagem, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 219, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(labelImagem, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 245, Short.MAX_VALUE)
                    .add(scrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 245, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(botaoAlterar)
                    .add(botaoExcluir)
                    .add(botaoAdicionar)
                    .add(botaoVer))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void treeValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_treeValueChanged
        // Obtém o nó selecionado (ATALHO):
        DefaultMutableTreeNode no = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
        
        // Obtém o nome do nó.
        String nome = null;
        if (no != null) {
            Object obj = no.getUserObject();
            if (obj instanceof Pais) nome = ((Pais)obj).getNome();
            else if (obj instanceof Estado) nome = ((Estado)obj).getNome();
            else if (obj instanceof Cidade) nome = ((Cidade)obj).getNome();
        }
        
        // Tenta obter uma imagem com o mesmo nome do nó.
        URL url = getClass().getResource("/resources/fotos/" + nome + ".jpg");
        
        // Se a imagem existe, exibe-a.
        if (url != null) labelImagem.setIcon(new ImageIcon(url));
        else labelImagem.setIcon(null);
    }//GEN-LAST:event_treeValueChanged

    private void botaoAlterarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botaoAlterarActionPerformed
        // Obtém o nó selecionado (ATALHO):
        DefaultMutableTreeNode no = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
        
        // Verifica se algum nó foi selecionado.
        if (no != null) {
            Object novo = null;
            String nome = JOptionPane.showInputDialog("Informe o novo nome:");
            
            // Verifica que tipo de nó está escolhido.
            Object obj = no.getUserObject();
            if (obj instanceof Pais) novo = new Pais(nome, ((Pais)obj).getCapital());
            else if (obj instanceof Estado) novo = new Estado(nome);
            else if (obj instanceof Cidade) novo = new Cidade(nome);
            
            // Troca o objeto e notifica.
            if (novo != null) no.setUserObject(novo);
            modelo.nodeChanged(no);
            mostraNo(no);
        }
        
    }//GEN-LAST:event_botaoAlterarActionPerformed

    private void botaoVerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botaoVerActionPerformed
        // Obtém o caminho selecionado.
        TreePath caminho = tree.getSelectionPath();
        if (caminho != null) {
            DefaultMutableTreeNode no = (DefaultMutableTreeNode)caminho.getLastPathComponent();
            if (no != null) JOptionPane.showMessageDialog(this, no.getUserObject() + " (" + no.getUserObject().getClass().getName() + ")");
        }
    }//GEN-LAST:event_botaoVerActionPerformed

    private void botaoExcluirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botaoExcluirActionPerformed
        // Obtém o nó selecionado (ATALHO):
        DefaultMutableTreeNode no = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
        
        // Se algum nó não-raiz foi escolhido, remove.
        if ((no != null) && (! no.isRoot())) modelo.removeNodeFromParent(no);
    }//GEN-LAST:event_botaoExcluirActionPerformed

    private void botaoAdicionarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botaoAdicionarActionPerformed
        // Obtém o nó selecionado (ATALHO):
        DefaultMutableTreeNode no = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();

        if (no != null) {
            // Verifica que tipo de nó está escolhido.
            Object obj = no.getUserObject();
            if (obj instanceof Pais) adicionarEstado(no);
            else if (obj instanceof Estado) adicionarCidade(no);
            else if (obj instanceof Cidade) adicionarCidade((DefaultMutableTreeNode)no.getParent());
        }
    }//GEN-LAST:event_botaoAdicionarActionPerformed
    
    private void adicionarEstado(DefaultMutableTreeNode no) {
        // Adiciona um novo estado. Obtém o nome.
        String nome = JOptionPane.showInputDialog("Informe o nome do novo estado:");
        if (nome != null) {
            // Cria o novo estado.
            Estado estado = new Estado(nome);
            DefaultMutableTreeNode novoNo = new DefaultMutableTreeNode(estado);
            novoNo.setAllowsChildren(true);

            // Adiciona à árvore, ao final do nó selecionado.
            modelo.insertNodeInto(novoNo, no, no.getChildCount());
            mostraNo(novoNo);
        }
    }
    
    private void adicionarCidade(DefaultMutableTreeNode no) {
        // Adiciona uma nova cidade. Obtém o nome.
        String nome = JOptionPane.showInputDialog("Informe o nome da nova cidade:");
        if (nome != null) {
            // Cria a nova cidade.
            Cidade cidade = new Cidade(nome);
            DefaultMutableTreeNode novoNo = new DefaultMutableTreeNode(cidade);
            novoNo.setAllowsChildren(false);

            // Adiciona à árvore, ao final do nó selecionado.
            modelo.insertNodeInto(novoNo, no, no.getChildCount());
            mostraNo(novoNo);
        }
    }
    
    private void mostraNo(DefaultMutableTreeNode no) {
        TreeNode[] nos = modelo.getPathToRoot(no);
        TreePath caminho = new TreePath(nos);
        tree.makeVisible(caminho);
        tree.scrollPathToVisible(caminho);
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new JanelaArvore().setVisible(true);
            }
        });
    }
    
    private void initModel() {
        // Cria um objeto país que representa o Brasil. Será a raiz da árvore.
        Pais brasil = Pais.buildBrasil();
        DefaultMutableTreeNode pais = new DefaultMutableTreeNode(brasil);
        
        // Adiciona ao nó raiz os diferentes estados.
        for (Estado e : brasil.getEstados()) {
            DefaultMutableTreeNode estado = new DefaultMutableTreeNode();
            estado.setUserObject(e);
            
            // Adiciona ao nó estado as diferentes cidades.
            for (Cidade c : e.getCidades()) {
                DefaultMutableTreeNode cidade = new DefaultMutableTreeNode(c);
                cidade.setAllowsChildren(false);
                estado.add(cidade);
            }
            
            pais.add(estado);
        }
        
        // Cria o modelo a partir do nó raiz e altera na árvore.
        modelo = new DefaultTreeModel(pais);
        tree.setModel(modelo);
        tree.setEditable(true);
        
        // Configura a árvore para mostrar a alça da raiz.
        // tree.setShowsRootHandles(true);
        
        // Configura a árvore para não mostrar a raiz.
        // tree.setRootVisible(false);
        
        // Configura o modelo para determinar o ícone do nó pela propriedade allowsChildren.
        modelo.setAsksAllowsChildren(true);
        
        // Configura o modo de seleção.
        tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        
        // Altera os ícones exibidos pela árvore.
        DefaultTreeCellRenderer renderer = new MyTreeCellRenderer();
        renderer.setLeafIcon(new ImageIcon(getClass().getResource("/resources/images/iconSeta.png")));
        renderer.setClosedIcon(new ImageIcon(getClass().getResource("/resources/images/iconPastaFechada.png")));
        renderer.setOpenIcon(new ImageIcon(getClass().getResource("/resources/images/iconPastaAberta.png")));
        tree.setCellRenderer(renderer);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botaoAdicionar;
    private javax.swing.JButton botaoAlterar;
    private javax.swing.JButton botaoExcluir;
    private javax.swing.JButton botaoVer;
    private javax.swing.JLabel labelImagem;
    private javax.swing.JScrollPane scrollPane;
    private javax.swing.JTree tree;
    // End of variables declaration//GEN-END:variables
    
    private class MyTreeCellRenderer extends DefaultTreeCellRenderer {
        public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus) {
            Component c = super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
            
            DefaultMutableTreeNode no = (DefaultMutableTreeNode)value;
            if (no.isRoot()) setIcon(new ImageIcon(getClass().getResource("/resources/images/iconMundo.png")));
            
            return c;
        }
    }
}
